﻿using IRaCIS.Core.Domain.BaseModel;
using IRaCIS.Core.Domain.Share;
using IRaCIS.Core.Domain.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Domain;

/// <summary>
/// 加急的医学反馈任务  通知MIM
/// </summary>
public class UrgentMedicalReviewAddedEvent : DomainEvent
{
    public Guid VisitTaskId { get; set; }
    public Guid MedicalReviewId { get; set; }

    public bool IsPD { get; set; }

}

//IR 回复医学反馈通知MIM
public class UrgentIRRepliedMedicalReview : DomainEvent
{
    public Guid ReadingMedicalReviewDialogId { get; set; }

    public Guid MedicalReviewId { get; set; }

    public bool IsPD { get; set; }
}

/// <summary>
/// MIM 回复医学返回通知IR
/// </summary>
public class UrgentMIMRepliedMedicalReview : DomainEvent
{
    public Guid ReadingMedicalReviewDialogId { get; set; }

    public Guid MedicalReviewId { get; set; }
}


/// <summary>
/// 加急阅片 IR 申请重阅  或者PM 申请重阅
/// </summary>
public class UrgentApplyedReReading : DomainEvent
{
    public Guid VisitTaskId { get; set; }

    public ReReadingApplyState ReReadingApplyState { get; set; }
}
